import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import peasy.test.*; 
import peasy.org.apache.commons.math.*; 
import peasy.*; 
import peasy.org.apache.commons.math.geometry.*; 
import controlP5.*; 

import java.util.HashMap; 
import java.util.ArrayList; 
import java.io.File; 
import java.io.BufferedReader; 
import java.io.PrintWriter; 
import java.io.InputStream; 
import java.io.OutputStream; 
import java.io.IOException; 

public class EXTRUDINGCIRCOS3 extends PApplet {

/**************************************************
 Mohit Hingorani
 Visualizing Information
 MAT259 - Winter 2014
 Final Project: Stairway to Heaven || Extruding Circos
 www.mohithingorani.com
 to be runi processing 2.0
 peasycam & controlP5 library 
 209-61-100
 **************************************************/







ControlP5 controlP5;

//import opengl.*;
PeasyCam cam;
int years=8;
int radius =400;
int sectors = years*12;
int stepHeight=12;
int startYear=2006;
String [] Month = {"January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"};
int noPL=10;
float dd,mm,yy;
float x,y,z;

//Hue,Saturation,Brightness
float Hue=209;
float Saturation=61;
float Brightness =100;
PFont myHelvetica = createFont("Helvetica",18);
PFont  myHelvetica12 = createFont("Helvetica",11,true);

Table[] table= new Table[noPL];
int []tableLength= new int[noPL];
//Table table[noPL];
//python ruby javascript java objective C
String cinString,coutString;
int rows=8000,columns=5;
int[][][] cinNumbersTable=new int[noPL][rows][columns];
int[][][] coutNumbersTable=new int[noPL][rows][columns];

float[][][] cinPositionsTable=new float[noPL][rows][3];
float[][][] coutPositionsTable=new float[noPL][rows][3];

  
boolean randomFlag= true;
boolean cFlag= true;
boolean sqlFlag= true;  
boolean phpFlag= true;
boolean lispFlag= true;
boolean perlFlag= true;
boolean pythonFlag= true;
boolean sectorFlag= true;


boolean objectiveCFlag= true;

boolean javaFlag= true;
boolean javaScriptFlag= true;
boolean rubyFlag= true;
boolean guiFlag = true;

PMatrix3D currCameraMatrix;
PGraphics3D g3; 

float[] position= new float[3];
public void setupGUI()
      {
              //controlP5.setAutoDraw(false);
              
              int locX=20,locY=300,diff=25;
              controlP5= new ControlP5(this);
              controlP5.setFont(myHelvetica12);
              controlP5.addSlider("Structure Hue",0,360,Hue,locX,200,160,diff-1);              
              controlP5.addSlider("Structure Saturation",0,100,Saturation,locX,200+diff,160,diff-1);              
              controlP5.addSlider("Structure Brightness",0,100,Brightness,locX,200+2*diff,160,diff-1);
              
              locY+=diff;
              controlP5.addToggle("Show Data",locX,locY,80* 2+diff ,diff-1);
              controlP5.controller("Show Data").setColorForeground(0xff63FF63);
              locY+=diff;
              
              controlP5.addButton("Python",1,locX,locY,80,diff-1);
              controlP5.controller("Python").setColorForeground(0xffFF6363);
              
              controlP5.addButton("Perl",1,locX + 80 +diff,locY,80,diff-1);
              controlP5.controller("Perl").setColorForeground(0xffB1FF63);
              locY+=diff;
              
              controlP5.addButton("ObjectiveC",1,locX,locY,80,diff-1);
              controlP5.controller("ObjectiveC").setColorForeground(0xff63FF63);
              
              controlP5.addButton("PHP",1,locX + 80 +diff,locY,80,diff-1);
              controlP5.controller("PHP").setColorForeground(0xffB163FF);
              locY+=diff;
              
              controlP5.addButton("Java",1,locX,locY,80,diff-1);
              controlP5.controller("Java").setColorForeground(0xff63FFFF);
              
              controlP5.addButton("C",1,locX + 80 +diff,locY,80,diff-1);
              controlP5.controller("C").setColorForeground(0xffFFB163);
              locY+=diff;
              
              controlP5.addButton("JavaScript",1,locX,locY,80,diff-1);
              controlP5.controller("JavaScript").setColorForeground(0xff6363FF);
              
              controlP5.addButton("SQL",1,locX + 80 +diff,locY,80,diff-1);
              controlP5.controller("SQL").setColorForeground(0xff63FFB1);
              
              locY+=diff;
              
              controlP5.addButton("Ruby",1,locX,locY,80,diff-1);
              controlP5.controller("Ruby").setColorForeground(0xffFF63FF);
              
              controlP5.addButton("Lisp",1,locX + 80 +diff,locY,80,diff-1);
              controlP5.controller("Lisp").setColorForeground(0xff63B1FF);
              locY+=diff;
              locY+=diff;
              controlP5.addButton("Reset",1,locX,locY,80,diff-1);
              controlP5.controller("Reset").setColorForeground(0xff63FFFF);
              locY+=diff;
              
              controlP5.addButton("View 1",1,locX,locY,80,diff-1);
              controlP5.controller("View 1").setColorForeground(0xff6363FF);
              locY+=diff;
              controlP5.addButton("View 2",1,locX,locY,80,diff-1);
              controlP5.controller("View 2").setColorForeground(0xff6363FF);
              locY+=diff;
              controlP5.addButton("View 3",1,locX,locY,80,diff-1);
              controlP5.controller("View 3").setColorForeground(0xff6363FF);
              locY+=diff;
              controlP5.addButton("View 4",1,locX,locY,80,diff-1);
              controlP5.controller("View 4").setColorForeground(0xff6363FF);
              
              
              
              
              
              
              controlP5.setAutoDraw(false);

        }  

public void drawGUI() 
      {
        currCameraMatrix = new PMatrix3D(g3.camera);
        camera();
        controlP5.draw();
        g3.camera = currCameraMatrix;
      }


public void controlEvent(ControlEvent theEvent) {
  
                 
                if(theEvent.isController()) {
                   
                  print("control event from : "+theEvent.controller().name());
                  println(", value : "+theEvent.controller().value());
                   
                   if(theEvent.controller().name()=="Python") {
                                                              pythonFlag=!pythonFlag;
                                                              }
                   if(theEvent.controller().name()=="PHP") {
                                                              phpFlag=!phpFlag;
                                                              }
                   if(theEvent.controller().name()=="Lisp") {
                                                              lispFlag=!lispFlag;
                                                              }
                   if(theEvent.controller().name()=="C") {
                                                              cFlag=!cFlag;
                                                              }
                   if(theEvent.controller().name()=="Perl") {
                                                              perlFlag=!perlFlag;
                                                              }
                   if(theEvent.controller().name()=="SQL") {
                                                              sqlFlag=!sqlFlag;
                                                              }
                    
                   if(theEvent.controller().name()=="ObjectiveC") {
                                                              objectiveCFlag=!objectiveCFlag;
                                                              }
                                                              
                   if(theEvent.controller().name()=="Java") {
                                                              javaFlag=!javaFlag;
                                                              }
                   
                   if(theEvent.controller().name()=="JavaScript") {
                                                              javaScriptFlag=!javaScriptFlag;
                                                              }
                   
                   if(theEvent.controller().name()=="Ruby") {
                                                              rubyFlag=!rubyFlag;
                                                              }
                   if(theEvent.controller().name()=="Structure Hue") {
                                                              Hue= theEvent.controller().value();
                                                              }
                   if(theEvent.controller().name()=="Structure Saturation") {
                                                              Saturation=theEvent.controller().value();
                                                              }
                   if(theEvent.controller().name()=="Structure Brightness") {
                                                              Brightness=theEvent.controller().value();
                                                              }      
                   if(theEvent.controller().name()=="Reset") {
                                                              cam.reset();
                                                              }       
                   if(theEvent.controller().name()=="View 1") {
                                                              
                                                              cam.setRotations(-radians(90),0,0);
                                                              cam.lookAt(0,0,500,500,1000);
                                                              }       
                   if(theEvent.controller().name()=="View 2") {
                                                              cam.setRotations(-radians(45),-radians(45),0);
                                                              cam.lookAt(0,0,800,400,2000);
                                                              }
                   if(theEvent.controller().name()=="View 3") {
                                                              cam.setRotations(-radians(45),-radians(45),0);
                                                              cam.lookAt(-125,75,342,300,3000);
                                                              }          
                   if(theEvent.controller().name()=="View 4") {
                                                              
                                                              cam.lookAt(0,0,500,1000,3000);
                                                              }                                                     
                   if(theEvent.controller().name()=="Show Data") {
                                                                 if(theEvent.controller().value()==1)
                                                                   {
                                                                   pythonFlag= false;
                                                                   objectiveCFlag= false;
                                                                   javaFlag= false;
                                                                   javaScriptFlag= false;
                                                                   rubyFlag= false;
                                                                   
                                                                   perlFlag= false;
                                                                   cFlag= false;
                                                                   phpFlag= false;
                                                                   lispFlag= false;
                                                                   sqlFlag= false;
                                                              
                                                                   } 
                                                                   else
                                                                  {
                                                                   pythonFlag= true;
                                                                   objectiveCFlag= true;
                                                                   javaFlag= true;
                                                                   javaScriptFlag= true;
                                                                   rubyFlag= true;
                                                                   
                                                                   perlFlag= true;
                                                                   cFlag= true;
                                                                   phpFlag= true;
                                                                   lispFlag= true;
                                                                   sqlFlag= true;
                                                                    }                  
                                                                 }
                }
}
public void displayDates(float sectorNumber)
        {
        pushMatrix();
        //rotate(sectorNumber* radians(30));
        //translate(0,0,sectorNumber*stepHeight);
        rotate(sectorNumber* radians(30)+ 3*radians(30));
        translate(0,0,stepHeight*16+sectorNumber*stepHeight);
        textFont(myHelvetica);
        textAlign(LEFT);
        fill(Hue,Saturation,Brightness,150);
        rotateX(radians(-90));
        rotateY(radians(60));   
        //rotateZ(radians(90));      
        
        text("  " +Month[PApplet.parseInt(sectorNumber%12)] +" "+ ( 2006+( PApplet.parseInt (sectorNumber/12))), radius/2,radius/2 );
        //text(Month[int(sectorNumber%12)] +" "+ ( 2005+( int (sectorNumber/12))), radius/2,radius/2 );
        popMatrix();
        }
public void draw()
      { 
        frameRate(60);
        background(0);
        fill(255);
        //box(10);
        //drawBezier();
        staticText();
        
        if (sectorFlag)
            {
            for (int sectorNumber=0 ; sectorNumber< sectors; sectorNumber++)
                {
                  drawArc(sectorNumber);
                  displayDates(sectorNumber);
                  
                  
                }
            }
        for (int pl=0; pl< noPL;pl++)
            { 
            for (int i=0; i< tableLength[pl];i++)
                {
               
                 //stroke(pl*60+60,Saturation,Brightness,160);
                 strokeWeight(1);
                 noFill();  
                 
               
                 if(pythonFlag && pl==0)
                   {
                   stroke(0xffFF6363,150);
                   bezier(cinPositionsTable[pl][i][0],cinPositionsTable[pl][i][1],cinPositionsTable[pl][i][2],
                         (cinPositionsTable[pl][i][0]+coutPositionsTable[pl][i][0])/6,(cinPositionsTable[pl][i][1]+coutPositionsTable[pl][i][1])/6,(cinPositionsTable[pl][i][2]+coutPositionsTable[pl][i][2])/1.78f,
                         (cinPositionsTable[pl][i][0]+coutPositionsTable[pl][i][0])/6,(cinPositionsTable[pl][i][1]+coutPositionsTable[pl][i][1])/6,(cinPositionsTable[pl][i][2]+coutPositionsTable[pl][i][2])/1.78f,
                          coutPositionsTable[pl][i][0],coutPositionsTable[pl][i][1],coutPositionsTable[pl][i][2]);
                  
                   }
                 if(objectiveCFlag && pl==1)
                   {
                   stroke(0xff63FF63,150);
                   bezier(cinPositionsTable[pl][i][0],cinPositionsTable[pl][i][1],cinPositionsTable[pl][i][2],
                         (cinPositionsTable[pl][i][0]+coutPositionsTable[pl][i][0])/6,(cinPositionsTable[pl][i][1]+coutPositionsTable[pl][i][1])/6,(cinPositionsTable[pl][i][2]+coutPositionsTable[pl][i][2])/1.78f,
                         (cinPositionsTable[pl][i][0]+coutPositionsTable[pl][i][0])/6,(cinPositionsTable[pl][i][1]+coutPositionsTable[pl][i][1])/6,(cinPositionsTable[pl][i][2]+coutPositionsTable[pl][i][2])/1.78f,
                          coutPositionsTable[pl][i][0],coutPositionsTable[pl][i][1],coutPositionsTable[pl][i][2]);
                   
                   }               
                 if(javaFlag && pl==2)
                     {
                       stroke(0xff63FFFF,150);
                       bezier(cinPositionsTable[pl][i][0],cinPositionsTable[pl][i][1],cinPositionsTable[pl][i][2],
                         (cinPositionsTable[pl][i][0]+coutPositionsTable[pl][i][0])/6,(cinPositionsTable[pl][i][1]+coutPositionsTable[pl][i][1])/6,(cinPositionsTable[pl][i][2]+coutPositionsTable[pl][i][2])/1.78f,
                         (cinPositionsTable[pl][i][0]+coutPositionsTable[pl][i][0])/6,(cinPositionsTable[pl][i][1]+coutPositionsTable[pl][i][1])/6,(cinPositionsTable[pl][i][2]+coutPositionsTable[pl][i][2])/1.78f,
                          coutPositionsTable[pl][i][0],coutPositionsTable[pl][i][1],coutPositionsTable[pl][i][2]);
                   
                     }
                 if(javaScriptFlag && pl==3)
                   {
                   stroke(0xff6363FF,150);
                   bezier(cinPositionsTable[pl][i][0],cinPositionsTable[pl][i][1],cinPositionsTable[pl][i][2],
                         (cinPositionsTable[pl][i][0]+coutPositionsTable[pl][i][0])/6,(cinPositionsTable[pl][i][1]+coutPositionsTable[pl][i][1])/6,(cinPositionsTable[pl][i][2]+coutPositionsTable[pl][i][2])/1.78f,
                         (cinPositionsTable[pl][i][0]+coutPositionsTable[pl][i][0])/6,(cinPositionsTable[pl][i][1]+coutPositionsTable[pl][i][1])/6,(cinPositionsTable[pl][i][2]+coutPositionsTable[pl][i][2])/1.78f,
                          coutPositionsTable[pl][i][0],coutPositionsTable[pl][i][1],coutPositionsTable[pl][i][2]);
                  
                   }
                 if(rubyFlag && pl==4)
                   {
                   stroke(0xffFF63FF,150);
                   bezier(cinPositionsTable[pl][i][0],cinPositionsTable[pl][i][1],cinPositionsTable[pl][i][2],
                         (cinPositionsTable[pl][i][0]+coutPositionsTable[pl][i][0])/6,(cinPositionsTable[pl][i][1]+coutPositionsTable[pl][i][1])/6,(cinPositionsTable[pl][i][2]+coutPositionsTable[pl][i][2])/1.78f,
                         (cinPositionsTable[pl][i][0]+coutPositionsTable[pl][i][0])/6,(cinPositionsTable[pl][i][1]+coutPositionsTable[pl][i][1])/6,(cinPositionsTable[pl][i][2]+coutPositionsTable[pl][i][2])/1.78f,
                          coutPositionsTable[pl][i][0],coutPositionsTable[pl][i][1],coutPositionsTable[pl][i][2]);
                   }
                 if(cFlag && pl==5)
                   {
                   stroke(0xffFFB163,150);
                   bezier(cinPositionsTable[pl][i][0],cinPositionsTable[pl][i][1],cinPositionsTable[pl][i][2],
                         (cinPositionsTable[pl][i][0]+coutPositionsTable[pl][i][0])/6,(cinPositionsTable[pl][i][1]+coutPositionsTable[pl][i][1])/6,(cinPositionsTable[pl][i][2]+coutPositionsTable[pl][i][2])/1.78f,
                         (cinPositionsTable[pl][i][0]+coutPositionsTable[pl][i][0])/6,(cinPositionsTable[pl][i][1]+coutPositionsTable[pl][i][1])/6,(cinPositionsTable[pl][i][2]+coutPositionsTable[pl][i][2])/1.78f,
                          coutPositionsTable[pl][i][0],coutPositionsTable[pl][i][1],coutPositionsTable[pl][i][2]);
                   }
                 if(perlFlag && pl==6)
                   {
                   stroke(0xffB1FF63,150);
                   bezier(cinPositionsTable[pl][i][0],cinPositionsTable[pl][i][1],cinPositionsTable[pl][i][2],
                         (cinPositionsTable[pl][i][0]+coutPositionsTable[pl][i][0])/6,(cinPositionsTable[pl][i][1]+coutPositionsTable[pl][i][1])/6,(cinPositionsTable[pl][i][2]+coutPositionsTable[pl][i][2])/1.78f,
                         (cinPositionsTable[pl][i][0]+coutPositionsTable[pl][i][0])/6,(cinPositionsTable[pl][i][1]+coutPositionsTable[pl][i][1])/6,(cinPositionsTable[pl][i][2]+coutPositionsTable[pl][i][2])/1.78f,
                          coutPositionsTable[pl][i][0],coutPositionsTable[pl][i][1],coutPositionsTable[pl][i][2]);
                   }
                 if(sqlFlag && pl==7)
                   {
                   stroke(0xff63FFB1,150);
                   bezier(cinPositionsTable[pl][i][0],cinPositionsTable[pl][i][1],cinPositionsTable[pl][i][2],
                         (cinPositionsTable[pl][i][0]+coutPositionsTable[pl][i][0])/6,(cinPositionsTable[pl][i][1]+coutPositionsTable[pl][i][1])/6,(cinPositionsTable[pl][i][2]+coutPositionsTable[pl][i][2])/1.78f,
                         (cinPositionsTable[pl][i][0]+coutPositionsTable[pl][i][0])/6,(cinPositionsTable[pl][i][1]+coutPositionsTable[pl][i][1])/6,(cinPositionsTable[pl][i][2]+coutPositionsTable[pl][i][2])/1.78f,
                          coutPositionsTable[pl][i][0],coutPositionsTable[pl][i][1],coutPositionsTable[pl][i][2]);
                   }
                 if(lispFlag && pl==8)
                   {
                   stroke(0xff63B1FF,150);
                   bezier(cinPositionsTable[pl][i][0],cinPositionsTable[pl][i][1],cinPositionsTable[pl][i][2],
                         (cinPositionsTable[pl][i][0]+coutPositionsTable[pl][i][0])/6,(cinPositionsTable[pl][i][1]+coutPositionsTable[pl][i][1])/6,(cinPositionsTable[pl][i][2]+coutPositionsTable[pl][i][2])/1.78f,
                         (cinPositionsTable[pl][i][0]+coutPositionsTable[pl][i][0])/6,(cinPositionsTable[pl][i][1]+coutPositionsTable[pl][i][1])/6,(cinPositionsTable[pl][i][2]+coutPositionsTable[pl][i][2])/1.78f,
                          coutPositionsTable[pl][i][0],coutPositionsTable[pl][i][1],coutPositionsTable[pl][i][2]);
                   }  
                 if(phpFlag && pl==9)
                   {
                   stroke(0xffB163FF,150);
                   bezier(cinPositionsTable[pl][i][0],cinPositionsTable[pl][i][1],cinPositionsTable[pl][i][2],
                         (cinPositionsTable[pl][i][0]+coutPositionsTable[pl][i][0])/6,(cinPositionsTable[pl][i][1]+coutPositionsTable[pl][i][1])/6,(cinPositionsTable[pl][i][2]+coutPositionsTable[pl][i][2])/1.78f,
                         (cinPositionsTable[pl][i][0]+coutPositionsTable[pl][i][0])/6,(cinPositionsTable[pl][i][1]+coutPositionsTable[pl][i][1])/6,(cinPositionsTable[pl][i][2]+coutPositionsTable[pl][i][2])/1.78f,
                          coutPositionsTable[pl][i][0],coutPositionsTable[pl][i][1],coutPositionsTable[pl][i][2]);
                   }   
                   
                       
                }
            }   
            
            
        //drawCircles();
      }
public void drawArc( float sectorNumber)
      {
        sectorNumber++;
        pushMatrix();  
        // draw the arcs     
        rotate(sectorNumber* radians(30));
        translate(0,0,sectorNumber*stepHeight);
        //stroke(0,0,50,150);
        fill(Hue,Saturation,Brightness,40);
        arc( 0,0, radius, radius,0,radians(30));
        
        //drawing the lines on the steps
        for ( int i=0; i<31;i++)
            {
             stroke(Hue,Saturation,Brightness,60);
             line(0,0,0,(radius/2)*cos(radians(i)),(radius/2)*sin(radians(i)),0);
            }
        

            
        popMatrix();
        
      }
      
public void drawCircles(float sectorNumber)
      {
       pushMatrix(); 
       noFill();
       stroke(0,0,100,150);
       translate(0,0,sectorNumber*stepHeight);
       ellipse(0,0,radius,radius);
       popMatrix();
      }
public void keyPressed()
      {
        if (key == 'p')
            pythonFlag=!pythonFlag;            
        if (key == 'o')    
            objectiveCFlag=!objectiveCFlag;
        if (key == 'j')                                                      
            javaFlag=!javaFlag;
        if (key == 's')   
            javaScriptFlag=!javaScriptFlag;
        if (key == 'r')    
            rubyFlag=!rubyFlag;
        if (key == 'l')    
            lispFlag=!lispFlag;
        if (key == 'h')    
            phpFlag=!phpFlag;
        if (key == 's')    
            sqlFlag=!sqlFlag;
        if (key == 'c')    
            cFlag=!cFlag; 
        if (key == 'e')    
            perlFlag=!perlFlag;    
        if (key == 'g')          
            guiFlag=!guiFlag;  
        if (key == 'f')          
            sectorFlag=!sectorFlag;      
        if (key == '+')    
            {
              if(sectors<=84)
                  sectors+=12;
            }
        if (key == '-')    
            {
              if(sectors>0)
                  sectors-=12;
            }
        
      }     
public void setup()
      {
        
           size(1440,900,P3D);
        
        //    size(1920,1080,OPENGL);
        frameRate(60);
        cam= new PeasyCam( this,0,0,stepHeight*years/2*12,3500);
        colorMode(HSB,360,100,100,255);
        cam.setMinimumDistance(50);
        cam.setMaximumDistance(3000);        
       
        controlP5 = new ControlP5(this);
        background(0,0,0);
        
        g3 = (PGraphics3D)g;
        
        setupGUI();
        
        /*
        table= new Table();
        table= loadTable("cs.csv","header");
        tableLength=table.getRowCount();
        */
        ////loading tables
        
        table[0]= loadTable("python.csv","header");
        tableLength[0]=table[0].getRowCount();
        
        
        table[1]= loadTable("objectivec.csv","header");
        tableLength[1]=table[1].getRowCount();
        
        
        table[2]= loadTable("java.csv","header");
        tableLength[2]=table[2].getRowCount();
        
        
        table[3]= loadTable("javascript.csv","header");
        tableLength[3]=table[3].getRowCount();
        
        
        table[4]= loadTable("ruby.csv","header");
        tableLength[4]=table[4].getRowCount();
        
        table[5]= loadTable("c.csv","header");
        tableLength[5]=table[5].getRowCount();
        
        table[6]= loadTable("perl.csv","header");
        tableLength[6]=table[6].getRowCount();
        
        table[7]= loadTable("sql.csv","header");
        tableLength[7]=table[7].getRowCount();
        
        table[8]= loadTable("lisp.csv","header");
        tableLength[8]=table[8].getRowCount();
        
        table[9]= loadTable("php.csv","header");
        tableLength[9]=table[9].getRowCount();
        
        
        for (int pl=0; pl< noPL;pl++)
            {
          
            for (int i=0; i< tableLength[pl];i++)
                {
                 cinString= table[pl].getString(i,0);
                 coutString= table[pl].getString(i,1);
    
                int cinNumbers[] = PApplet.parseInt(splitTokens(cinString, "- "));             
                int coutNumbers[] =PApplet.parseInt(splitTokens(coutString, "- "));
                
                for (int matrix=0;matrix<3;matrix++)
                    {
                      cinNumbersTable[pl][i][matrix] =cinNumbers[matrix];
                      coutNumbersTable[pl][i][matrix] =coutNumbers[matrix];                  
                    }
                              
                              
                }
        }    
//conversion to cylendrical cordinates
    for (int pl=0; pl< noPL;pl++)
        {
        for (int i=0; i< tableLength[pl];i++)
             {
              //cintable 
                cinPositionsTable[pl][i][0]= radius/2* cos((radians(30*cinNumbersTable[pl][i][1])+radians(cinNumbersTable[pl][i][2])));    // major rotations by mm , minor rotations with dd
                cinPositionsTable[pl][i][1]= radius/2* sin((radians(30*cinNumbersTable[pl][i][1])+radians(cinNumbersTable[pl][i][2])));
                cinPositionsTable[pl][i][2]= (cinNumbersTable[pl][i][0]-startYear)*stepHeight*12+ cinNumbersTable[pl][i][1]*stepHeight;  ///geeting to the right height
                
              //cout table  
                coutPositionsTable[pl][i][0]= radius/2* cos((radians(30*coutNumbersTable[pl][i][1])+radians(coutNumbersTable[pl][i][2])));    // major rotations by mm , minor rotations with dd
                coutPositionsTable[pl][i][1]= radius/2* sin((radians(30*coutNumbersTable[pl][i][1])+radians(coutNumbersTable[pl][i][2])));
                coutPositionsTable[pl][i][2]= (coutNumbersTable[pl][i][0]-startYear)*stepHeight*12+ coutNumbersTable[pl][i][1]*stepHeight;  ///geeting to the right height
                
             }   
        }  
            //println(cinNumbersTable[0][1]);
            
            
      }
public void staticText()
      {
      cam.beginHUD();
      position= cam.getPosition();
      //size(240,height);
      background(0,0,0,100);
      textFont(myHelvetica);
      textAlign(LEFT,BASELINE);
      fill(209,61,100,200);
      text("MAT259 Final Project",20,height-100 );
      text("By Mohit Hingorani",20,height-80 );
      text("Winter 2014",20,height-120 );
      text("Chasing Programming Languages || Extruding Circos",20,40 );
      text("Final 3D Interactive Visualization",20,60 );
      
      
      textFont(myHelvetica12);
      text(" The visualization shows the relationship between the checkin and checkouts of popular \nprogramming languages in the Seattle Public Library. The data is for 8 years from 2006-2013",20,100); 
      
      text(" Camera Position  X: " + position[0]+" Y: "+ position[1]+ " Z: "+ position[2],20,160);
      text("framerate " + frameRate +" fps" ,20,180);
      
      
      if (guiFlag)
            drawGUI();
      cam.endHUD();
      }
      //camera.beginHUD();
      // now draw things that you want relative to the camera's position and orientation
      //camera.endHUD(); // always!
  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "--full-screen", "--bgcolor=#666666", "--stop-color=#cccccc", "EXTRUDINGCIRCOS3" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
